<?php 
/**
 * @package Debt Countdown Clock
 * @version 1.0.0
 */
/*
Plugin Name: Debt Countdown Clock
Description: Will replace [shnugi_debt_clock_countdown] in a widget with a debt clock count down. The settings menu is located at Settings -> Debt Countdown Clock. Created by <a href="http://www.shnugi.com">Shnugi Personal Finance</a> and <a href="http://www.faithfuldividends.com/">Faithful Dividends</a>.
Author: Shnugi / Faithful Dividends
Version: 1.0.0
Author URI: 
*/

//Description: Conditionally includes wp functions, when the script is pulled up for search functions such as when the jQuery & search forms interact.
if(!function_exists('get_bloginfo'))
{
	require("../../../wp-blog-header.php");
}
//Adding the hooks
else
{
	add_shortcode('shnugi_debt_clock_countdown', 'shnugi_debt_clock_countdown_data' );
	add_action( 'admin_menu', 'shnugi_debt_clock_countdown_menu' );
	add_action('admin_enqueue_scripts', 'shnugi_add_e2_date_picker'); 
	add_filter('widget_text','do_shortcode');
}	

//Code from http://www.e2soft.com/blog/add-a-jquery-date-picker-to-wordpress-theme-or-plugin/ hook in jQuery UI CSS from Google. This is for the date picker.
function shnugi_add_e2_date_picker(){
	//jQuery UI date picker file
	wp_enqueue_script('jquery-ui-datepicker');
	//jQuery UI theme css file
	wp_enqueue_style('e2b-admin-ui-css','http://ajax.googleapis.com/ajax/libs/jqueryui/1.9.0/themes/base/jquery-ui.css',false,"1.9.0",false);
}

//Add admin menu
function shnugi_debt_clock_countdown_menu() {
	add_options_page( 'Debt Countdown Clock Options', 'Debt Countdown Clock', 'manage_options', 'shnugi-debt-clock-countdown', 'shnugi_debt_clock_countdown_options' );
}

//Admin menu options
function shnugi_debt_clock_countdown_options() {
	if ( !current_user_can( 'manage_options' ) )  {
		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
	}
	// variables for the field and option names 

    $hidden_field_name = 'shnugi_debt_clock_cd_submit_hidden';
    $debt_amount_name = 'shnugi_debt_clock_cd_amount';
	$start_date_name = 'shnugi_debt_clock_cd_start';
	$end_date_name = 'shnugi_debt_clock_cd_end';
	$shnugi_include_links = 'shnugi_debt_clock_include_links';


    // See if the user has posted us some information
    // If they did, this hidden field will be set to 'Y'
    if( isset($_POST[ $hidden_field_name ]) && $_POST[ $hidden_field_name ] == 'Y' ) {
    // Read their posted value
    $opt_val = $_POST[ $debt_amount_name ];
	//Validation checks for inputs before updating the option values.
	if(is_numeric($opt_val)==true)
	{
		update_option( $debt_amount_name, $opt_val );
	}
	else{
		?>
	<div class="updated"><p><strong>Debt value is not numeric. Please enter your debt with no commas, negatives, or dollar signs</strong></p></div>
		<?php
	}
	$opt_val = $_POST[ $start_date_name ];
	if(strlen($opt_val)==10 && intval(substr($opt_val,5,2))<=12 && intval(substr($opt_val,9,2))<32 && is_numeric(substr($opt_val,0,4))==true)
	{
		update_option( $start_date_name, $opt_val );
	}
	else{
		?>
		<div class="updated"><p><strong>Start date is not in YYYY-MM-DD format.</strong></p></div>
		<?php
	}
	$opt_val = $_POST[ $end_date_name ];
	if(strlen($opt_val)==10 && intval(substr($opt_val,5,2))<=12 && intval(substr($opt_val,9,2))<32 && is_numeric(substr($opt_val,0,4))==true)
	{
		update_option( $end_date_name, $opt_val );
	}
	else{
		?>
		<div class="updated"><p><strong>End date is not in YYYY-MM-DD format.</strong></p></div>
		<?php
	}
	$opt_val = $_POST[ $shnugi_include_links ];
	if($opt_val == "Y")
	{
		update_option( $shnugi_include_links, $opt_val );
	}
	else{
		
		update_option( $shnugi_include_links, "N" );
	}

    // Save the posted value in the database
    

    // Put a "settings saved" message on the screen

?>
<div class="updated"><p><strong><?php _e('settings saved.', 'menu-test' ); ?></strong></p></div>
<?php
	
    }
	// Read in existing option value from database

    $debt_opt_val = get_option( $debt_amount_name );
	$start_opt_val = get_option( $start_date_name );
	$end_opt_val = get_option( $end_date_name );
	$include_links = get_option ( $shnugi_include_links);
	
    // Now display the settings editing screen

    echo '<div class="wrap">';

    // header

    echo "<h2>" . __( 'Debt Countdown Clock Plugin Settings', 'shnugi-menu-debt-countdown' ) . "</h2>";

    // settings form
    
    ?>

<form name="debt_countdown_update" method="post" action="">
<input type="hidden" name="<?php echo $hidden_field_name; ?>" value="Y">
<p><?php _e("Current Debt Amount:", 'shnugi-menu-debt-countdown' ); ?> 
$<input type="text" name="<?php echo $debt_amount_name; ?>" value="<?php echo $debt_opt_val; ?>" size="20">
</p>
<p><?php _e("Date of Current Debt Amount:", 'shnugi-menu-debt-countdown' ); ?> 
<input type="text" name="<?php echo $start_date_name; ?>" class="datepicker" value="<?php echo $start_opt_val; ?>" size="20">
</p>
<p><?php _e("Date of Debt Payoff:", 'shnugi-menu-debt-countdown' ); ?> 
<input type="text" name="<?php echo $end_date_name; ?>" class="datepicker" value="<?php echo $end_opt_val; ?>" size="20">
</p>
<p><?php _e("Share the love, include small links to <a href='http://www.shnugi.com'>Shnugi Personal Finance</a> and <a href='http://www.faithfuldividends.com/'>Faithful Dividends</a> under the clock:", 'shnugi-menu-debt-countdown' ); ?> 
<input type="checkbox" name="<?php echo $shnugi_include_links; ?>"  value="Y" <?php if($include_links == "Y") {echo 'checked="checked"'; } ?> >
</p><hr />
<p class="submit">
<input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
</p>
<b>Instructions</b><br>
Use this shortcode <b>[shnugi_debt_clock_countdown]</b> to include the clock on posts, pages, or text widgets.<br>
<ol>
<li>Enter in your current amount of debt with no commas or dollar signs. (Example: 10000)</li>
<li>Enter the date of when you counted all of your debt. This could be in the past or today. (Example: pick today)</li>
<li>Enter the date that you anticipate paying off all of your debt. Make sure this value is after the date you entered in step 2. (Example: pick the day 2 months from now)</li>
</ol>

	<script>
            jQuery(function() {
                jQuery( ".datepicker" ).datepicker({
                    dateFormat : "yy-mm-dd"
                });
            });
   </script> 
</form>
</div>

<?php
 
}

//Countdown clock short code code
function shnugi_debt_clock_countdown_data()
{
	ob_start();
	setlocale(LC_MONETARY, 'en_US.UTF-8');
	//option names
	$debt_amount_name = 'shnugi_debt_clock_cd_amount';
	$start_date_name = 'shnugi_debt_clock_cd_start';
	$end_date_name = 'shnugi_debt_clock_cd_end';
	$shnugi_include_links = 'shnugi_debt_clock_include_links';
	//get current values
	$debt_opt_val = get_option( $debt_amount_name );
	$start_opt_val = get_option( $start_date_name );
	$end_opt_val = get_option( $end_date_name );
	$links_opt_val = get_option( $shnugi_include_links );
	
	//find the jQuery.Countdown plugin code
	echo '<script type="text/javascript" src="' . plugins_url( 'jquery.countdown.min.js', __FILE__ ) . '"></script>';
	
	$datetime1 = date_create($start_opt_val);
    $datetime2 = date_create($end_opt_val);
	$interval = date_diff($datetime1, $datetime2);
    $total_time_diff = ($interval->format("%a"))*24*60*20;
	//Speed to decrement.
	$amount_per_second = max($debt_opt_val / $total_time_diff, .0001);
	
	$datetime_now = date_create_from_format('Y-m-d H:i:s',date("Y-m-d H:i:s"));
	$interval = date_diff($datetime_now, $datetime2);
    $total_time_diff_now = ($interval->format("%a"))*24*60*20;
	$total_time_diff_now = $total_time_diff_now + ($interval->format("%h"))*60*20;
	$total_time_diff_now = $total_time_diff_now + ($interval->format("%i"))*20;

	$start_debt_value = $debt_opt_val - ($total_time_diff - $total_time_diff_now) * $amount_per_second;
	?><script type="text/javascript">
Number.prototype.formatMoney=function(t,e,r){var a=this,t=isNaN(t=Math.abs(t))?2:t,e=void 0==e?".":e,r=void 0==r?",":r,n=0>a?"-":"",o=String(parseInt(a=Math.abs(Number(a)||0).toFixed(t))),u=(u=o.length)>3?u%3:0;return n+(u?o.substr(0,u)+r:"")+o.substr(u).replace(/(\d{3})(?=\d)/g,"$1"+r)+(t?e+Math.abs(a-o).toFixed(t).slice(2):"")},jQuery(function(){setInterval(function(){jQuery(".debt_countdown_val").each(function(){
	var t=jQuery(this).text(),e=Number(t.replace(/[^0-9\.]+/g,"")),r=e;
	r =r - <?php echo $amount_per_second; ?>;
jQuery(this).text("$"+r.formatMoney(4,".",","))})},2e3)});
	</script><script type="text/javascript">
	jQuery(function(){
	  jQuery(".debt_countdown_days").each(function(){
			jQuery(this).countdown("<?php echo $end_opt_val;?>", function(event) {
				  var format = '%H:%M:%S';
				  if(event.offset.daysToMonth > 0) {
					format = '%-n day%!n ' + format;
				  }
				  if(event.offset.months > 0) {
					format = '%-m month%!m ' + format;
				  }

				jQuery(this).text(
				  event.strftime(format)
				);
			  });
		  });
	  });
	</script><?php
	echo "<div style = 'width:100%; background-color: #eee; padding:6px; border-style: solid; border-width:1px; border-color:#ccc;'>";
	echo "<span style='font-size:1.1em; font-weight:bold;'>Countdown to Debt Freedom</span><br>";
	echo "<b>Debt Left: <span class='debt_countdown_val' style='color:red'>". money_format('%.4n',  round($start_debt_value,2))."</span>";
	echo "<br>";
	echo "Debt Free in: <span class='debt_countdown_days'></span></b>";
	//Conditionally include created by links if the setting is checked.
	if($links_opt_val == "Y")
	{
		echo '<br><small>Created by <a href="http://www.shnugi.com">Shnugi Personal Finance</a> and <a href="http://www.faithfuldividends.com/">Faithful Dividends</a>.</small>'; 
	}
	echo "</div>";
	
	$html = ob_get_contents();
    ob_end_clean();
	return $html;
	

}

?>